VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Bar As PictureBox
Private m_Val As Long
Private m_Min As Long
Private m_Max As Long
Private m_fColor As Long
Private m_bColor As Long
Private m_CellWidth As Integer
Private m_CellHeight As Integer
Private m_xMargin As Integer
Private m_yMargin As Integer
Private m_Cells As Integer

Private Sub Class_Initialize()
   
   Set m_Bar = Nothing
   m_Val = 0
   m_Min = 0
   m_Max = 100
   m_fColor = vbHighlight
   m_bColor = vb3DFace

End Sub

Public Property Set Client(ByVal NewObj As Object)
   
   If TypeName(NewObj) = "PictureBox" Then
      Set m_Bar = NewObj
      m_Bar.ForeColor = m_fColor
      m_Bar.BackColor = m_bColor
      m_Bar.ScaleMode = vbPixels
      Resize
   Else
      
      Err.Raise Number:=13, _
         Source:="CProgressBar.Client", _
         Description:="Client property must be of type PictureBox."
   End If
End Property

Public Property Get Client() As Object
   Set Client = m_Bar
End Property

Public Property Let Value(NewVal As Long)
   Dim PrevVal As Long
   PrevVal = m_Val
   Select Case NewVal
      Case Is > m_Max
         m_Val = m_Max
      Case Is < m_Min
         m_Val = m_Min
      Case Else
         m_Val = NewVal
   End Select
   Refresh
End Property

Public Property Get Value() As Long
   Value = m_Val
End Property

Public Property Let Min(NewVal As Long)
   If NewVal < m_Max Then
      m_Min = NewVal
      Refresh
   Else
      Err.Raise Number:=vbObjectError + 2, _
                Source:="CProgressBar.Min", _
                Description:="Min property must be less than Max."
   End If
End Property

Public Property Get Min() As Long
   Min = m_Min
End Property

Public Property Let Max(NewVal As Long)
   If NewVal > m_Min Then
      m_Max = NewVal
      Refresh
   Else
      Err.Raise Number:=vbObjectError + 3, _
                Source:="CProgressBar.Max", _
                Description:="Max property must be greater than Min."
   End If
End Property

Public Property Get Max() As Long
   Max = m_Max
End Property

Public Property Let ForeColor(NewVal As Long)
   m_fColor = NewVal
   If Not m_Bar Is Nothing Then
      m_Bar.ForeColor = m_fColor
      Refresh
   End If
End Property

Public Property Get ForeColor() As Long
   ForeColor = m_fColor
End Property

Public Property Let BackColor(NewVal As Long)
   m_bColor = NewVal
   If Not m_Bar Is Nothing Then
      m_Bar.BackColor = m_bColor
      Refresh
   End If
End Property

Public Property Get BackColor() As Long
   BackColor = m_bColor
End Property
Public Sub Refresh(Optional ClearFirst)
   If Not m_Bar Is Nothing Then
      If Not IsMissing(ClearFirst) Then
         If ClearFirst Then
            m_Bar.Cls
         End If
      End If
      RedrawMe
   End If
End Sub

Public Sub Resize()
   CalcCellSize
   Refresh True
End Sub

Public Sub ResizeEx()
   Dim xActual As Integer
   Dim xPicture As Integer
   Dim dLarge As Integer
   Dim dSmall As Integer
   Dim xExtra As Integer
   Static Recursing As Boolean
   If Recursing Then Exit Sub
   CalcCellSize
   xActual = m_xMargin + m_Cells * (m_CellWidth + m_xMargin)
   xPicture = m_Bar.ScaleWidth
   dLarge = xActual - xPicture
   dSmall = xPicture - (xActual - m_CellWidth - m_xMargin)
   If dSmall <= dLarge Then
      m_Cells = m_Cells - 1
      xActual = m_xMargin + m_Cells * (m_CellWidth + m_xMargin)
   End If
   xExtra = m_Bar.Width - (xPicture * Screen.TwipsPerPixelX)
   Recursing = True
      m_Bar.Width = xActual * Screen.TwipsPerPixelX + xExtra
   Recursing = False
   Refresh True
End Sub

Private Sub RedrawMe()
   Dim i As Long
   Dim x As Long
   Dim y As Long
   Dim n As Long
   n = ((m_Val - m_Min) / (m_Max - m_Min)) * m_Cells
   m_Bar.ForeColor = m_fColor
   y = m_yMargin + m_CellHeight - 1
   x = m_yMargin
   For i = 1 To n
      m_Bar.Line (x, m_yMargin)-(x + m_CellWidth, y), , BF
      x = x + m_xMargin + m_CellWidth
   Next i
   If n < m_Cells Then
      m_Bar.ForeColor = m_bColor
      For i = n + 1 To m_Cells
         m_Bar.Line (x, m_yMargin)-(x + m_CellWidth, y), , BF
         x = x + m_xMargin + m_CellWidth
      Next i
   End If
End Sub

Private Sub CalcCellSize()
   m_yMargin = 2
   m_xMargin = 3
   m_CellHeight = m_Bar.ScaleHeight - m_yMargin * 2
   m_CellWidth = m_CellHeight * (2 / 3)
   m_Cells = m_Bar.ScaleWidth \ (m_CellWidth + m_xMargin) + 1
End Sub
